<?php
class logger {
    function logger() {
        if (is_single()) {
            global $wpdb;
            global $post;
            $section = get_post_meta($post->ID, 'e_section', true);
            $page = get_post_meta($post->ID, 'e_section_page', true);

if (($section == '') || ($page == '')) return;
            
            $location = geoip_record_by_name($_SERVER['REMOTE_ADDR']);
            #$location = geoip_record_by_name('174.96.193.121');
#print_r($location);
            $table_name = $wpdb->prefix . "e_section";

           $rows_affected = $wpdb->insert($table_name, 
                array( 
                    'section' => $section, 
                    'page' => $page,
                    'city' => $location['city'],
                    'postal_code' => $location['postal_code'])
            );
        }
    }
    
    function get_sections() {
        global $wpdb;
        $table_name = $wpdb->prefix . "e_section";
        $interval = $_GET['interval'];
        
        
        $sql = "SELECT section, count(id) as c FROM " . $table_name;
        if ($interval) {
            $sql .= " WHERE ts >= DATE_SUB(NOW(), INTERVAL ". $interval . " HOUR) ";
        }
        $sql .= " GROUP BY section";
        
        $rows = $wpdb->get_results($sql);
        return $rows;
    }
    
    function get_pages($section='a') {
        global $wpdb;
        $table_name = $wpdb->prefix . "e_section";
        $interval = $_GET['interval'];
        
        $sql = "SELECT page, count(id) as c FROM " . $table_name;
        $sql .= " WHERE section='" . $section . "' ";
        if ($interval) {
            $sql .= " AND ts >= DATE_SUB(NOW(), INTERVAL " . $interval . " HOUR) ";
        }
        $sql .= " GROUP BY page";
        
        $rows = $wpdb->get_results($sql);
        return $rows;        
    }
    
    
    function view() {
        ?>
        	<div class="wrap" id="e-section-wrap">
        	    <div id="e-section-title">
        	        <h2>E-Section - Logger</h2>
        	    </div>
        	</div>
        	<div class="wrap">
        	<a href="?page=e-section-logger">All</a> -
        	<a href="?page=e-section-logger&interval=72">Last 72 hours</a> -
        	<a href="?page=e-section-logger&interval=24">Last 24 hours</a>
        	</div>
        <?php
        $sections = $this->get_sections();
        
        print '<div id="e_section_log_results">';
        foreach ($sections as $section) {
            print '<div class="section">';
            print "Section " . strtoupper($section->section) . ": " . $section->c . "<br/>";
            $pages = $this->get_pages($section->section);
            foreach ($pages as $page) {
                print '<span class="page">Page ' . strtoupper($section->section) . $page->page . ': ' . $page->c . '</span>';
            }
            print "</div>";
        }
        print "</div>";
    }
}

?>
